#ifndef PPH_SORT_UTIL_HH_INCLUDED
#define PPH_SORT_UTIL_HH_INCLUDED

#include <algorithm>


namespace pphSortUtil
{
    namespace
    {
        struct IndirectCompare
        {
            const int * const values;

            IndirectCompare(const int * const values)
                : values(values)
            {}

            bool operator() (int left, int right) const
            {
                return values[left] < values[right];
            }
        };
    }



    inline void indirectSort(int *indirection, int *values, int length)
    {
        std::sort(indirection, indirection + length, IndirectCompare(values));
    }
}



#endif
